> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://apidocs.polytomic.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://apidocs.polytomic.com/_mcp/server.

# Run Query

POST https://app.polytomic.com/api/connections/{connection_id}/query
Content-Type: application/json

Submits a query for asynchronous execution against the connection.

This endpoint returns immediately with a query task ID. It does not wait for
the query to finish. Poll [`GET /api/queries/{id}`](../../../../api-reference/query-runner/get-query) until `status`
reaches `done`, `failed`, or `unknown`. These statuses are terminal.

Only the user who created the query can fetch its results later. Query results
are stored temporarily and may expire; use the `expires` field from the result
endpoint to understand how long they will remain available.

Reference: https://apidocs.polytomic.com/2024-02-08/api-reference/query-runner/run-query

## Authentication

- `Authorization` header (basic auth, required) — This is the Polytomic deployment key (on-premises only)
- `Authorization` header (bearer token, required) — This is the Polytomic API key

## Request

### Path parameters

- `connection_id` (string, required) — Unique identifier of the connection to run the query against.

### Query parameters

- `query` (string, optional) — The query to execute against the connection.

### Headers

- `X-Polytomic-Harbor-Session` (string, optional)
- `X-Polytomic-Activity-Request-ID` (string, optional)

## Response

### 200

OK

- `data` (V4RunQueryResult, optional)

## Errors

### 400 Bad Request Error

Bad Request

- `key` (string, optional)
- `message` (string, optional)
- `metadata` (map from string to any, optional)
- `status` (integer, optional)

### 401 Unauthorized Error

Unauthorized

- `code` (integer, optional) — Application-specific error code.
- `context` (map from string to any, optional) — Application context.
- `error` (string, optional) — Error message.
- `status` (string, optional) — Status text.

### 403 Forbidden Error

Forbidden

- `key` (string, optional)
- `message` (string, optional)
- `metadata` (map from string to any, optional)
- `status` (integer, optional)

### 404 Not Found Error

Not Found

- `key` (string, optional)
- `message` (string, optional)
- `metadata` (map from string to any, optional)
- `status` (integer, optional)

### 409 Conflict Error

Conflict

- `key` (string, optional)
- `message` (string, optional)
- `metadata` (map from string to any, optional)
- `status` (integer, optional)

### 500 Internal Server Error

Internal Server Error

- `key` (string, optional)
- `message` (string, optional)
- `metadata` (map from string to any, optional)
- `status` (integer, optional)

### 503 Service Unavailable Error

Service Unavailable

- `key` (string, optional)
- `message` (string, optional)
- `metadata` (map from string to any, optional)
- `status` (integer, optional)

## Types

### V4RunQueryResult

- `count` (long, optional) — The number of rows returned by the query. This will not be returned until the query completes.
- `error` (string, optional) — Error message if the query failed.
- `expires` (string, optional) — The time at which the query will expire and be deleted. This will not be returned until the query completes.
- `fields` (list of string, optional) — The names of the fields returned by the query. This will not be returned until the query completes.
- `id` (string, optional) — The ID of the query task. Poll GET /api/queries/\{id} until the task reaches the terminal status done, failed, or unknown.
- `results` (list of map from string to any, optional) — The query results, returned as an array of objects.
- `status` (enum, optional)
  - Allowed values: `created`, `running`, `unknown`, `done`, `failed`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "data": {
    "count": 10,
    "error": "string",
    "expires": "2021-01-01T00:00:00Z",
    "fields": [
      "name",
      "age"
    ],
    "id": "43d893ef-322b-47da-badb-3cf10d13a556",
    "results": [
      {}
    ],
    "status": "created"
  }
}
```

**SDK Code**

```typescript
import { PolytomicClient } from "polytomic";

async function main() {
    const client = new PolytomicClient({
        token: "YOUR_TOKEN_HERE",
        version: "X-Polytomic-Version",
    });
    await client.queryRunner.runQuery("248df4b7-aa70-47b8-a036-33ac447e668d", {});
}
main();

```

```python
from polytomic import Polytomic

client = Polytomic(
    token="YOUR_TOKEN_HERE",
    version="X-Polytomic-Version",
)

client.query_runner.run_query(
    connection_id="248df4b7-aa70-47b8-a036-33ac447e668d",
)

```

```go
package example

import (
    context "context"

    polytomic "github.com/polytomic/polytomic-go/v24"
    client "github.com/polytomic/polytomic-go/v24/client"
    option "github.com/polytomic/polytomic-go/v24/option"
)

func do() {
    client := client.NewClient(
        option.WithToken(
            "YOUR_TOKEN_HERE",
        ),
        option.WithVersion(
            "X-Polytomic-Version",
        ),
    )
    request := &polytomic.V4RunQueryRequest{}
    client.QueryRunner.RunQuery(
        context.TODO(),
        "248df4b7-aa70-47b8-a036-33ac447e668d",
        request,
    )
}

```

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.polytomic.com/api/connections/248df4b7-aa70-47b8-a036-33ac447e668d/query")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Polytomic-Version"] = 'X-Polytomic-Version'
request.basic_auth("<username>", "<password>")
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://app.polytomic.com/api/connections/248df4b7-aa70-47b8-a036-33ac447e668d/query")
  .header("X-Polytomic-Version", "X-Polytomic-Version")
  .basicAuth("<username>", "<password>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://app.polytomic.com/api/connections/248df4b7-aa70-47b8-a036-33ac447e668d/query', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-Polytomic-Version' => 'X-Polytomic-Version',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://app.polytomic.com/api/connections/248df4b7-aa70-47b8-a036-33ac447e668d/query");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Polytomic-Version", "X-Polytomic-Version");

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "X-Polytomic-Version": "X-Polytomic-Version",
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://app.polytomic.com/api/connections/248df4b7-aa70-47b8-a036-33ac447e668d/query")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```